<template>
  <div class="admin-configurator overflow-hidden fixed z-1 inset-0" @click="closeAdminConfigurator">
    <div ref="configuratorWrapper" class="flex h-full justify-center items-center">
      <div
        id="adminConfigurator"
        ref="configuratorContent"
        class="admin-configurator__content xs:overflow-auto animated-modal xs:fixed bottom-0 left-0 xs:w-full bg-bgdsec p-8 xs:px-4 xs:pt-4 rounded-32 xs:rounded-t-32 xs:rounded-b-none"
        @click.stop
      >
        <div class="admin-configurator__scrollarea">
          <div class="flex items-center justify-between">
            <p class="text-txtdprim font-bold text-2xl leading-7 xs:text-lg xs:leading-6">Configurator</p>
            <UiButton button-height="sm" color-type="secondary" class="w-12 rounded-16" @click="closeAdminConfigurator">
              <img width="24" height="24" src="@/assets/images/ui/ui-cross.svg" />
            </UiButton>
          </div>
          <div class="mt-8 flex gap-2 items-center">
            <p class="text-txtdsec font-medium">Chain</p>
            <div>
              <img width="20" height="20" src="@/assets/images/ui/ui-info.svg" />
            </div>
          </div>
          <UiDropdown v-model="value.chain" :options="coins" class="mt-4" />
          <div class="mt-8 flex gap-2 items-center">
            <p class="text-txtdsec font-medium">Public Address</p>
            <div>
              <img width="20" height="20" src="@/assets/images/ui/ui-info.svg" />
            </div>
          </div>
          <UiInput v-model="publicAddress" class="mt-4 rounded-16" />
          <div class="grid grid-cols-2 xs:grid-cols-1 gap-8 xs:gap-4">
            <div>
              <div class="mt-8 flex gap-2 items-center">
                <p class="text-txtdsec font-medium">Network</p>
                <div>
                  <img width="20" height="20" src="@/assets/images/ui/ui-info.svg" />
                </div>
              </div>
              <UiRange v-model="value.network" :values="networks" class="mt-4" />
            </div>
            <div>
              <div class="mt-8 flex gap-2 items-center">
                <p class="text-txtdsec font-medium">Node mode</p>
                <div>
                  <img width="20" height="20" src="@/assets/images/ui/ui-info.svg" />
                </div>
              </div>
              <UiRange v-model="value.mode" :values="modes" class="mt-4" />
            </div>
          </div>
          <div class="mt-8 xs:mt-4">
            <div class="flex items-center gap-2">
              <p class="font-medium text-txtdsec">Period</p>
              <p class="font-medium text-txtdtert">{{ value.period.title }}</p>
            </div>
            <UiRange v-model="value.period" :values="periods" class="mt-4" />
          </div>
          <UiButton
            button-height="md"
            color-type="primary"
            class="mt-12 xs:mt-8 rounded-24 gap-3"
            @click="createProject"
          >
            <template v-if="!loading">
              <p>Create Project</p>
            </template>
            <LoadingSpinner color-type="white" v-else />
          </UiButton>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { createProject } from '@/api/admin';

import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';
import UiInput from '@/components/ui/UiInput.vue';
import UiButton from '@/components/ui/UiButton.vue';
import UiRange from '@/components/ui/UiRange.vue';
import UiDropdown from '@/components/ui/UiDropdown.vue';
import ProjectConfigurations from '@/mixins/ProjectConfigurations';

export default {
  name: 'AdminConfigurator',

  components: { UiInput, UiButton, UiRange, UiDropdown, LoadingSpinner },

  mixins: [ProjectConfigurations],

  data() {
    return {
      coins: [
        {
          key: 'ETH',
          title: 'Ethereum',
        },
        {
          key: 'BTC',
          title: 'Bitcoin',
        },
        {
          key: 'BSC',
          title: 'BNB Smart Chain',
        },
        {
          key: 'SOL',
          title: 'Solana',
        },
        {
          key: 'APT',
          title: 'Aptos',
        },
        {
          key: 'AVAX',
          title: 'Avalanche',
        },
        {
          key: 'MATIC',
          title: 'Polygon',
        },
      ],

      value: {
        chain: {
          title: 'Ethereum',
          key: 'ETH',
        },
        network: {
          title: 'Mainnet',
          key: 'mainnet',
        },
        mode: {
          title: 'Full',
          key: 'full',
        },
        period: {
          title: '3 days',
          key: '3d',
        },
      },

      publicAddress: '',

      loading: false,
    };
  },

  methods: {
    closeAdminConfigurator() {
      this.$emit('close');
    },

    async createProject() {
      this.loading = true;
      const reqBody = this.createRequestBody();

      try {
        await createProject(this.publicAddress, reqBody);
        this.closeAdminConfigurator();
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'Project successfully created.',
        });
        this.$emit('update-projects');
      } catch (err) {
        console.error(err);
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'User not found.',
          status: 'error',
        });
      } finally {
        this.loading = false;
      }
    },

    createRequestBody() {
      const reqBody = {} as { [key: string]: number | string };

      reqBody.mode = this.value.mode.key;
      reqBody.network = this.value.network.key;
      reqBody.cryptocurrency_symbol = this.value.chain.key;

      const currentDate = new Date();
      let expiredDate;

      if (this.value.period.key === '3d')
        expiredDate = new Date(currentDate.getUTCFullYear(), currentDate.getUTCMonth(), currentDate.getUTCDate() + 3);
      else if (this.value.period.key === '1m')
        expiredDate = new Date(currentDate.getUTCFullYear(), currentDate.getUTCMonth() + 1, currentDate.getUTCDate());
      else if (this.value.period.key === '3m')
        expiredDate = new Date(currentDate.getUTCFullYear(), currentDate.getUTCMonth() + 3, currentDate.getUTCDate());

      reqBody.pay_until = `${expiredDate.getUTCFullYear()}-${
        expiredDate.getUTCMonth() < 9 ? '0' + (expiredDate.getUTCMonth() + 1) : expiredDate.getUTCMonth() + 1
      }-${expiredDate.getUTCDate() < 9 ? '0' + (expiredDate.getUTCDate() + 1) : expiredDate.getUTCDate() + 1}`;

      return reqBody;
    },
  },
};
</script>

<style lang="scss">
.admin-configurator {
  background: rgba(12, 21, 33, 0.64);

  &__content {
    width: 500px;

    @media (max-width: 600px) {
      max-height: calc(100vh - 120px);
    }
  }
}
</style>
